﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip
{
    public class EntityWarmlyShip : EntityShip
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия труб
        /// </summary>
        public bool Pipes { get; private set; }
        /// <summary>
        /// Признак наличия топливного отсека
        /// </summary>
        public bool FuelCompartment { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес коробля</param>
        /// <param name="bodyColor">Цвет коробля</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="pipes">Признак наличия труб</param>
        /// <param name="fuelCompartment">Признак наличия топливного отсека</param>
        public EntityWarmlyShip(int speed, float weight, Color bodyColor, Color dopColor, bool pipes, bool fuelCompartment) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            Pipes = pipes;
            FuelCompartment = fuelCompartment;
        }
    }
}
