﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip
{
    internal static class ExtentionShip
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static DrawningShip CreateDrawningShip(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningShip(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawningWarmlyShip(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningAirplane"></param>
        /// <returns></returns>
        public static string GetDataForSave(this DrawningShip drawningShip)
        {
            var Ship = drawningShip.Ship;
            var str = $"{Ship.Speed}{_separatorForObject}{Ship.Weight}{_separatorForObject}{Ship.BodyColor.Name}";
            if (Ship is not EntityWarmlyShip WarmlyShip)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{WarmlyShip.DopColor.Name}{_separatorForObject}{WarmlyShip.Pipes}{_separatorForObject}{WarmlyShip.FuelCompartment}";
        }
    }
}
