namespace WarmlyShip
{
    public partial class FormShip : Form
    {
        private DrawningShip _ship;
        public DrawningShip SelectedShip { get; private set; }
        public FormShip()
        {
            InitializeComponent();
         }
        /// <summary>
		///   
		/// </summary>
        private void SetData()
        {
            Random rnd = new();
            _ship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxShip.Width, pictureBoxShip.Height);
            toolStripStatusLabelSpeed.Text = $": {_ship.Ship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_ship.Ship.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_ship.Ship.BodyColor.Name}";
        }
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxShip.Width, pictureBoxShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _ship?.DrawTransport(gr);
            pictureBoxShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _ship = new DrawningShip(rnd.Next(100, 300), rnd.Next(1000, 2000),
           color);
            SetData();
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _ship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _ship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _ship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _ship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256),
           rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _ship = new DrawningWarmlyShip(rnd.Next(100, 300), rnd.Next(1000, 2000),
           color, dopColor,
            Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0,
           2)));
            SetData();
            Draw();

        }

        private void ButtonSelectShip_Click(object sender, EventArgs e)
        {
            SelectedShip = _ship;
            DialogResult = DialogResult.OK;
        }
    }
}